   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE
!INCLUDE('CharFileIO.Inc'), ONCE

   MAP
     MODULE('EMBEDS_BC.CLW')
DctInit     PROCEDURE                                      ! Initializes the dictionary definition module
DctKill     PROCEDURE                                      ! Kills the dictionary definition module
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('EMBEDS001.CLW')
Main                   PROCEDURE   !Wizard Application for C:\cci-eclipse\ClarionMag\web\_apps\embeds\Embeds.dct
     END
   END

GLO:Owner            STRING('CMagRackShack {238}')
GLO:TextFileName     STRING('empty.txt {246}')
SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'

!region File Declaration
Embed                FILE,DRIVER('TOPSPEED'),PRE(EMB),BINDABLE,CREATE,THREAD !                    
PRIMARY                  KEY(EMB:EmbedID),PRIMARY          !                    
EmbedProcIDIndex         KEY(EMB:EmbedProcID),DUP          !                    
Contents                    BLOB                           !                    
Record                   RECORD,PRE()
EmbedID                     LONG                           !                    
EmbedChainID                LONG                           !                    
EmbedProcID                 LONG                           !                    
LinesOfCode                 LONG                           !                    
Embed                       CSTRING(6000)                  !                    
Param1                      CSTRING(61)                    !                    
Param2                      CSTRING(61)                    !                    
Param3                      CSTRING(61)                    !                    
Priority                    LONG                           !                    
                         END
                     END                       

EmbedApp             FILE,DRIVER('TOPSPEED'),PRE(EMA),BINDABLE,CREATE,THREAD !                    
PRIMARY                  KEY(EMA:EmbedAppID),PRIMARY       !                    
Record                   RECORD,PRE()
EmbedAppID                  LONG                           !                    
TXA                         CSTRING(61)                    !                    
EmbedChainID                LONG                           !                    
                         END
                     END                       

EmbedProc            FILE,DRIVER('TOPSPEED'),PRE(EMP),BINDABLE,CREATE,THREAD !                    
PRIMARY                  KEY(EMP:EmbedProcID),PRIMARY      !                    
EmbedAppIDIndex          KEY(EMP:EmbedAppID),DUP           !                    
Record                   RECORD,PRE()
EmbedProcID                 LONG                           !                    
EmbedAppID                  LONG                           !                    
EmbedChainID                LONG                           !                    
Proc                        CSTRING(61)                    !                    
ProcFromABC                 CSTRING(61)                    !                    
ProcCategory                CSTRING(61)                    !                    
                         END
                     END                       

TextFile             FILE,DRIVER('ASCII'),NAME(glo:TextFileName),PRE(TXT),CREATE,BINDABLE,THREAD !                    
Record                   RECORD,PRE()
rec                         STRING(1000)                   !                    
                         END
                     END                       

!endregion

Access:Embed         &FileManager,THREAD                   ! FileManager for Embed
Relate:Embed         &RelationManager,THREAD               ! RelationManager for Embed
Access:EmbedApp      &FileManager,THREAD                   ! FileManager for EmbedApp
Relate:EmbedApp      &RelationManager,THREAD               ! RelationManager for EmbedApp
Access:EmbedProc     &FileManager,THREAD                   ! FileManager for EmbedProc
Relate:EmbedProc     &RelationManager,THREAD               ! RelationManager for EmbedProc
Access:TextFile      &FileManager,THREAD                   ! FileManager for TextFile
Relate:TextFile      &RelationManager,THREAD               ! RelationManager for TextFile

FuzzyMatcher         FuzzyClass                            ! Global fuzzy matcher
GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               INIClass                              ! Global non-volatile storage manager
GlobalRequest        BYTE(0),THREAD                        ! Set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE(0),THREAD                        ! Set to the response from the form
VCRRequest           LONG(0),THREAD                        ! Set to the request from the VCR buttons

Dictionary           CLASS,THREAD
Construct              PROCEDURE
Destruct               PROCEDURE
                     END


  CODE
  GlobalErrors.Init(GlobalErrorStatus)
  FuzzyMatcher.Init                                        ! Initilaize the browse 'fuzzy matcher'
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)            ! Configure case matching
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)          ! Configure 'word only' matching
  INIMgr.Init('.\embeds.INI', NVD_INI)                     ! Configure INIManager to use INI file
  DctInit
  Main
  INIMgr.Update
  INIMgr.Kill                                              ! Destroy INI manager
  FuzzyMatcher.Kill                                        ! Destroy fuzzy matcher


Dictionary.Construct PROCEDURE

  CODE
  IF THREAD()<>1
     DctInit()
  END


Dictionary.Destruct PROCEDURE

  CODE
  DctKill()

