  MEMBER('embeds.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
embeds_BC0:DctInit    PROCEDURE
embeds_BC0:DctKill    PROCEDURE
embeds_BC0:FilesInit  PROCEDURE
  END

Hide:Access:Embed    CLASS(FileManager),TYPE               ! FileManager for Embed
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Embed    CLASS(RelationManager),TYPE           ! RelationManager for Embed
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:EmbedApp CLASS(FileManager),TYPE               ! FileManager for EmbedApp
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:EmbedApp CLASS(RelationManager),TYPE           ! RelationManager for EmbedApp
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:EmbedProc CLASS(FileManager),TYPE              ! FileManager for EmbedProc
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:EmbedProc CLASS(RelationManager),TYPE          ! RelationManager for EmbedProc
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:TextFile CLASS(FileManager),TYPE               ! FileManager for TextFile
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:TextFile CLASS(RelationManager),TYPE           ! RelationManager for TextFile
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


_Hide:Access:Embed   &Hide:Access:Embed,AUTO,THREAD
_Hide:Relate:Embed   &Hide:Relate:Embed,AUTO,THREAD
_Hide:Access:EmbedApp &Hide:Access:EmbedApp,AUTO,THREAD
_Hide:Relate:EmbedApp &Hide:Relate:EmbedApp,AUTO,THREAD
_Hide:Access:EmbedProc &Hide:Access:EmbedProc,AUTO,THREAD
_Hide:Relate:EmbedProc &Hide:Relate:EmbedProc,AUTO,THREAD
_Hide:Access:TextFile &Hide:Access:TextFile,AUTO,THREAD
_Hide:Relate:TextFile &Hide:Relate:TextFile,AUTO,THREAD


embeds_BC0:DctInit PROCEDURE
  CODE
  _Hide:Access:Embed &= NEW(Hide:Access:Embed)
  _Hide:Relate:Embed &= NEW(Hide:Relate:Embed)
  _Hide:Access:EmbedApp &= NEW(Hide:Access:EmbedApp)
  _Hide:Relate:EmbedApp &= NEW(Hide:Relate:EmbedApp)
  _Hide:Access:EmbedProc &= NEW(Hide:Access:EmbedProc)
  _Hide:Relate:EmbedProc &= NEW(Hide:Relate:EmbedProc)
  _Hide:Access:TextFile &= NEW(Hide:Access:TextFile)
  _Hide:Relate:TextFile &= NEW(Hide:Relate:TextFile)
  Relate:Embed &= _Hide:Relate:Embed
  Relate:EmbedApp &= _Hide:Relate:EmbedApp
  Relate:EmbedProc &= _Hide:Relate:EmbedProc
  Relate:TextFile &= _Hide:Relate:TextFile


embeds_BC0:FilesInit PROCEDURE
  CODE
  _Hide:Relate:Embed.Init
  _Hide:Relate:EmbedApp.Init
  _Hide:Relate:EmbedProc.Init
  _Hide:Relate:TextFile.Init


embeds_BC0:DctKill PROCEDURE
  CODE
  _Hide:Relate:Embed.Kill
  DISPOSE(_Hide:Relate:Embed)
  _Hide:Relate:EmbedApp.Kill
  DISPOSE(_Hide:Relate:EmbedApp)
  _Hide:Relate:EmbedProc.Kill
  DISPOSE(_Hide:Relate:EmbedProc)
  _Hide:Relate:TextFile.Kill
  DISPOSE(_Hide:Relate:TextFile)


Hide:Relate:Embed.Init PROCEDURE
  CODE
  _Hide:Access:Embed.Init
  SELF.Init(Access:Embed,1)


Hide:Access:Embed.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= EMB:Record
  SELF.FileNameValue = 'Embed'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Embed
  PARENT.Init
  Access:Embed &= SELF


Hide:Access:Embed.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Embed &= NULL                                     ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Embed.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Embed,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(EMB:PRIMARY,'EMB:PRIMARY',0)
    SELF.AddKey(EMB:EmbedProcIDIndex,'EMB:EmbedProcIDIndex',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Embed.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:EmbedProc)


Hide:Relate:Embed.Kill PROCEDURE

  CODE
  _Hide:Access:Embed.Kill                                  ! Kill the file manager
  PARENT.Kill
  Relate:Embed &= NULL                                     ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Embed)                              ! destroy the file manager


Hide:Relate:EmbedApp.Init PROCEDURE
  CODE
  _Hide:Access:EmbedApp.Init
  SELF.Init(Access:EmbedApp,1)


Hide:Access:EmbedApp.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= EMA:Record
  SELF.FileNameValue = 'EmbedApp'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= EmbedApp
  PARENT.Init
  Access:EmbedApp &= SELF


Hide:Access:EmbedApp.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:EmbedApp &= NULL                                  ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:EmbedApp.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(EmbedApp,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(EMA:PRIMARY,'EMA:PRIMARY',1)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:EmbedApp.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:EmbedProc,RI:None,RI:None,EMP:EmbedAppIDIndex)
  SELF.AddRelationLink(EMA:EmbedAppID,EMP:EmbedAppID)


Hide:Relate:EmbedApp.Kill PROCEDURE

  CODE
  _Hide:Access:EmbedApp.Kill                               ! Kill the file manager
  PARENT.Kill
  Relate:EmbedApp &= NULL                                  ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:EmbedApp)                           ! destroy the file manager


Hide:Relate:EmbedProc.Init PROCEDURE
  CODE
  _Hide:Access:EmbedProc.Init
  SELF.Init(Access:EmbedProc,1)


Hide:Access:EmbedProc.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= EMP:Record
  SELF.FileNameValue = 'EmbedProc'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= EmbedProc
  PARENT.Init
  Access:EmbedProc &= SELF


Hide:Access:EmbedProc.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:EmbedProc &= NULL                                 ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:EmbedProc.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(EmbedProc,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(EMP:PRIMARY,'EMP:PRIMARY',1)
    SELF.AddKey(EMP:EmbedAppIDIndex,'EMP:EmbedAppIDIndex',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:EmbedProc.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:EmbedApp)

  SELF.AddRelation(Relate:Embed,RI:None,RI:None,EMB:EmbedProcIDIndex)
  SELF.AddRelationLink(EMP:EmbedProcID,EMB:EmbedProcID)


Hide:Relate:EmbedProc.Kill PROCEDURE

  CODE
  _Hide:Access:EmbedProc.Kill                              ! Kill the file manager
  PARENT.Kill
  Relate:EmbedProc &= NULL                                 ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:EmbedProc)                          ! destroy the file manager


Hide:Relate:TextFile.Init PROCEDURE
  CODE
  _Hide:Access:TextFile.Init
  SELF.Init(Access:TextFile,1)


Hide:Access:TextFile.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= TXT:Record
  SELF.FileNameValue = 'TextFile'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= TextFile
  SELF.FileName &= glo:TextFileName
  PARENT.Init
  Access:TextFile &= SELF


Hide:Access:TextFile.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:TextFile &= NULL                                  ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:TextFile.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(TextFile,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:TextFile.Kill PROCEDURE

  CODE
  _Hide:Access:TextFile.Kill                               ! Kill the file manager
  PARENT.Kill
  Relate:TextFile &= NULL                                  ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:TextFile)                           ! destroy the file manager

